"use strict";
/**
 * @license
 * Copyright 2019 Google Inc. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var saved_model_1 = require("./saved_model");
// tslint:disable-next-line:no-require-imports
var messages = require('./proto/api_pb');
describe('SavedModel', function () {
    it('deserialize SavedModel pb file', function () { return __awaiter(_this, void 0, void 0, function () {
        var modelMessage, signatureDefMapMessage, inputsMapMessage, inputsMapKeys, inputsMapKey1, inputTensorMessage, outputsMapMessage, outputsMapKeys, outputsMapKey1, outputTensorMessage;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, saved_model_1.readSavedModelProto('./test_objects/times_three_float')];
                case 1:
                    modelMessage = _a.sent();
                    // This SavedModel has one MetaGraph with tag serve
                    expect(modelMessage.getMetaGraphsList().length).toBe(1);
                    expect(modelMessage.getMetaGraphsList()[0]
                        .getMetaInfoDef()
                        .getTagsList()
                        .length)
                        .toBe(1);
                    expect(modelMessage.getMetaGraphsList()[0].getMetaInfoDef().getTagsList()[0])
                        .toBe('serve');
                    signatureDefMapMessage = modelMessage.getMetaGraphsList()[0].getSignatureDefMap();
                    expect(signatureDefMapMessage.has('serving_default'));
                    inputsMapMessage = signatureDefMapMessage.get('serving_default').getInputsMap();
                    expect(inputsMapMessage.getLength()).toBe(1);
                    inputsMapKeys = inputsMapMessage.keys();
                    inputsMapKey1 = inputsMapKeys.next();
                    expect(inputsMapKey1.done).toBe(false);
                    expect(inputsMapKey1.value).toBe('x');
                    inputTensorMessage = inputsMapMessage.get(inputsMapKey1.value);
                    expect(inputTensorMessage.getName()).toBe('serving_default_x:0');
                    expect(saved_model_1.getEnumKeyFromValue(messages.DataType, inputTensorMessage.getDtype()))
                        .toBe('DT_FLOAT');
                    outputsMapMessage = signatureDefMapMessage.get('serving_default').getOutputsMap();
                    expect(outputsMapMessage.getLength()).toBe(1);
                    outputsMapKeys = outputsMapMessage.keys();
                    outputsMapKey1 = outputsMapKeys.next();
                    expect(outputsMapKey1.done).toBe(false);
                    expect(outputsMapKey1.value).toBe('output_0');
                    outputTensorMessage = outputsMapMessage.get(outputsMapKey1.value);
                    expect(outputTensorMessage.getName()).toBe('StatefulPartitionedCall:0');
                    expect(saved_model_1.getEnumKeyFromValue(messages.DataType, outputTensorMessage.getDtype()))
                        .toBe('DT_FLOAT');
                    return [2 /*return*/];
            }
        });
    }); });
    it('get enum key based on value', function () {
        var DataType = messages.DataType;
        var enumKey0 = saved_model_1.getEnumKeyFromValue(DataType, 0);
        expect(enumKey0).toBe('DT_INVALID');
        var enumKey1 = saved_model_1.getEnumKeyFromValue(DataType, 1);
        expect(enumKey1).toBe('DT_FLOAT');
        var enumKey2 = saved_model_1.getEnumKeyFromValue(DataType, 2);
        expect(enumKey2).toBe('DT_DOUBLE');
    });
    it('read non-exist file', function (done) { return __awaiter(_this, void 0, void 0, function () {
        var err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, saved_model_1.readSavedModelProto('/not-exist')];
                case 1:
                    _a.sent();
                    done.fail();
                    return [3 /*break*/, 3];
                case 2:
                    err_1 = _a.sent();
                    expect(err_1.message)
                        .toBe("There is no saved_model.pb file in the directory: /not-exist");
                    done();
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('inspect SavedModel metagraphs', function () { return __awaiter(_this, void 0, void 0, function () {
        var modelInfo;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, saved_model_1.getMetaGraphsFromSavedModel('./test_objects/times_three_float')];
                case 1:
                    modelInfo = _a.sent();
                    /**
                     * The inspection output should be
                     * [{
                     *  'tags': ['serve'],
                     *  'signatureDefs': {
                     *      '__saved_model_init_op': {
                     *        'inputs': [],
                     *        'outputs': [{'dtype': 'DT_INVALID', 'name': 'NoOp', 'shape': []}]
                     *      },
                     *      'serving_default': {
                     *        'inputs': [
                     *          {'dtype': 'DT_FLOAT', 'name': 'serving_default_x:0', 'shape':
                     * []}
                     *        ],
                     *        'outputs': [{
                     *          'dtype': 'DT_FLOAT',
                     *          'name': 'StatefulPartitionedCall:0',
                     *          'shape': []
                     *        }]
                     *      }
                     *   }
                     * }]
                     */
                    expect(modelInfo.length).toBe(1);
                    expect(modelInfo[0].tags.length).toBe(1);
                    expect(modelInfo[0].tags[0]).toBe('serve');
                    expect(Object.keys(modelInfo[0].signatureDefs).length).toBe(2);
                    expect(Object.keys(modelInfo[0].signatureDefs)[0])
                        .toBe('__saved_model_init_op');
                    expect(Object.keys(modelInfo[0].signatureDefs)[1]).toBe('serving_default');
                    expect(Object.keys(modelInfo[0].signatureDefs['serving_default'].inputs)
                        .length)
                        .toBe(1);
                    expect(modelInfo[0].signatureDefs['serving_default'].inputs['x'].name)
                        .toBe('serving_default_x:0');
                    expect(modelInfo[0].signatureDefs['serving_default'].inputs['x'].dtype)
                        .toBe('DT_FLOAT');
                    expect(Object.keys(modelInfo[0].signatureDefs['serving_default'].outputs)
                        .length)
                        .toBe(1);
                    expect(modelInfo[0].signatureDefs['serving_default'].outputs['output_0'].name)
                        .toBe('StatefulPartitionedCall:0');
                    expect(modelInfo[0].signatureDefs['serving_default'].outputs['output_0'].dtype)
                        .toBe('DT_FLOAT');
                    return [2 /*return*/];
            }
        });
    }); });
});
